#include <stdio.h>
#include <stdbool.h>
#include <assert.h>


/* Renvoie la longueur du string s */
int my_strlen(char* s){
	int len = 0;
	while (s[len] != '\0'){
		len = len + 1;
	}
	return len;
}

/* Recopie le string src dans dst */
void my_strcpy(char* dst, char* src){
	int i = 0;
	while (src[i] != '\0'){
		dst[i] = src[i];
		i++;
	}
	// ne pas oublier le caractère nul
	dst[i] = '\0';
}

/* Concatène le string src à la fin de dst */
void my_strcat(char* dst, char* src){
	// trouver la fin de dst
	int fin_dst = my_strlen(dst);
	// rajouter les caractères de src
	int i = 0;
	while (src[i] != '\0'){
		dst[fin_dst + i] = src[i];
		i++;
	}
	// ne pas oublier le caractère nul
	dst[fin_dst + i] = '\0';
}

/* Renvoie un entier comparant s1 et s2 dans l'ordre alphabétique:
   0 si égalité
   un entier < 0 si s1 < s2
   un entier > 0 si s1 > s2 */
int my_strcmp(char* s1, char* s2){
	int i = 0;
	while (s1[i] != '\0' && s2[i] != '\0'){
		if (s1[i] != s2[i]){
			return s1[i] - s2[i];
		}
		i++;
	}
	// en sortie: soit s1[i] = 0 soit s2[i] = 0 soit les deux
	return s1[i] - s2[i];
}



int main(){
	char bateau[20] = "bateau";
	char sur_leau[10] = "sur l'eau";
	char bateau_sur_leau[20] = "bateausur l'eau";
	char vide[20] = "";

	assert(my_strlen(bateau) == 6);
	assert(my_strlen(vide)== 0);

	assert(my_strcmp("arbre", "bateau") < 0); 
	assert(my_strcmp("chat", "bateau") > 0);
	assert(my_strcmp(bateau, "bateau") == 0);
	assert(my_strcmp("bat", "bateau") < 0); // cas où une chaîne est préfixe de l'autre

	my_strcpy(vide, bateau);
	assert(my_strcmp(vide, "bateau") == 0);

	my_strcat(bateau, sur_leau);
	assert(my_strcmp(bateau_sur_leau, bateau) == 0);

	return 0;
}